%define upstream_name	 CGI-SpeedyCGI
%define upstream_version 2.22
%define mod_name mod_speedycgi

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %{upstream_version}
Release:    %mkrel 31
Summary:    Speed up perl scripts by running them persistently
License:    GPLv3+
Group:      Development/Perl
Url:		https://metacpan.org/release/%{upstream_name}
Source0:	https://cpan.metacpan.org/modules/by-authors/id/H/HO/HORROCKS/%{upstream_name}-%{upstream_version}.tar.gz
Source1:	mod_speedycgi.conf
Source2:	speedycgi.conf
Source3:	example.conf
Patch0:		perl-CGI-SpeedyCGI-2.22-documentation.patch
Patch1:		perl-CGI-SpeedyCGI-2.22-empty_param.patch
Patch2:		perl-CGI-SpeedyCGI-2.22-strerror.patch
Patch3:		perl-CGI-SpeedyCGI-2.22-brigade_foreach.patch
Patch4:		perl-CGI-SpeedyCGI-2.22-exit_messages.patch
Patch5:		perl-CGI-SpeedyCGI-2.22-perl_510.patch
Patch6:		perl-CGI-SpeedyCGI-2.22-c99_inline.patch
Patch7:		CGI-SpeedyCGI-2.22-Fix-building-on-Perl-without-dot-in-INC.patch
# Fix building with GCC 10, bug #1793916, CPAN RT#131596
Patch8:         CGI-SpeedyCGI-2.22-Fix-building-with-GCC-10.patch
Patch9:         perl-CGI-SpeedyCGI-c99.patch
BuildRequires:	perl-devel
BuildRequires:	apache-devel
BuildRequires:  pkgconfig(apr-1)
BuildRequires:  pkgconfig(libsystemd)

%description
SpeedyCGI is a way to run perl scripts persistently, which can make them run
much more quickly. A script can be made to to run persistently by changing the
interpreter line at the top of the script from:
    #!/usr/bin/perl
to
    #!/usr/bin/speedy
After the script is initially run, instead of exiting, the perl interpreter is
kept running. During subsequent runs, this interpreter is used to handle new
executions instead of starting a new perl interpreter each time. A very fast
frontend program, written in C, is executed for each request. This fast
frontend then contacts the persistent Perl process, which is usually already
running, to do the work and return the results.

%package -n	apache-%{mod_name}
Summary:	SpeedyCGI module for the Apache HTTP Server
Group:		System/Servers
Requires:	apache
Requires:	%{name} = %{version}-%{release}

%description -n	apache-%{mod_name}
The SpeedyCGI module for the Apache HTTP Server. It can be used to run perl
scripts for web application persistently to make them more quickly.

%prep
%autosetup -p1 -n %{upstream_name}-%{upstream_version}

cp %{SOURCE1} %{mod_conf}
cp -pf %{SOURCE3} .

%build
%serverbuild

#sed -i 's@apxs -@%{_sbindir}/apxs -@g' Makefile.PL src/SpeedyMake.pl \
#  mod_speedycgi/t/ModTest.pm mod_speedycgi/t/mod_perl.t
#sed -i 's@APXS=apxs@APXS=%{_sbindir}/apxs@g' mod_speedycgi/Makefile.tmpl

echo yes | perl Makefile.PL INSTALLDIRS=vendor
make OPTIMIZE="$CFLAGS -Wno-incompatible-pointer-types" LDFLAGS="%{ldflags}"

#check
##- this test does not work with 5.8.7.
#rm speedy/t/be_memleak.t
#make test

%install
make pure_install PERL_INSTALL_ROOT=%{buildroot}

install -D -m 755 mod_speedycgi2/.libs/*.so %{buildroot}%{_httpd_moddir}/mod_speedycgi.so
install -D -m 644 %{SOURCE1} %{buildroot}%{_httpd_modconfdir}/10_mod_speedycgi.conf
install -D -m 644 %{SOURCE2} %{buildroot}%{_httpd_extconfdir}/speedycgi.conf

%files
%doc Changes README docs contrib util
%{perl_vendorlib}/CGI/*
%{_bindir}/speedy*

%files -n apache-%{mod_name}
%config(noreplace) %{_httpd_modconfdir}/10_mod_speedycgi.conf
%config(noreplace) %{_httpd_extconfdir}/speedycgi.conf
%{_httpd_moddir}/mod_speedycgi.so


%changelog
* Tue Aug 27 2024 daviddavid <daviddavid> 2.220.0-31.mga10
+ Revision: 2091611
- Add -Wno-incompatible-pointer-types to CFLAGS
+ tv <tv>
- Fix build
+ neoclust <neoclust>
- Rebuild against new perl

* Thu Nov 30 2023 tv <tv> 2.220.0-30.mga10
+ Revision: 2011554
- Rebuild for perl-5.38

* Mon Jun 06 2022 umeabot <umeabot> 2.220.0-29.mga9
+ Revision: 1861596
- Rebuild for Perl 5.36

* Wed Mar 30 2022 umeabot <umeabot> 2.220.0-28.mga9
+ Revision: 1834182
- Mageia 9 Mass Rebuild

* Tue May 25 2021 tmb <tmb> 2.220.0-27.mga9
+ Revision: 1728016
- rebuild for perl 5.34
+ umeabot <umeabot>
- Rebuild for perl 5.34

* Fri Aug 21 2020 joequant <joequant> 2.220.0-25.mga8
+ Revision: 1617179
- add systemd lib

* Wed Jun 17 2020 umeabot <umeabot> 2.220.0-24.mga8
+ Revision: 1594316
- Rebuild for perl 5.32

* Wed May 13 2020 tv <tv> 2.220.0-23.mga8
+ Revision: 1583557
- fix build with gcc-10
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Tue Aug 27 2019 tmb <tmb> 2.220.0-21.mga8
+ Revision: 1433381
- rebuild for perl 5.30

* Fri Sep 21 2018 umeabot <umeabot> 2.220.0-20.mga7
+ Revision: 1292369
- Mageia 7 Mass Rebuild

* Tue Aug 07 2018 pterjan <pterjan> 2.220.0-19.mga7
+ Revision: 1248958
- Rebuild for perl 5.28

* Mon Oct 02 2017 tv <tv> 2.220.0-18.mga7
+ Revision: 1163267
- rebuild with fixed rpm for missing autodeps

* Thu Aug 31 2017 pterjan <pterjan> 2.220.0-17.mga7
+ Revision: 1149477
- Rebuild for perl ABI changes

* Tue Jul 25 2017 sander85 <sander85> 2.220.0-16.mga7
+ Revision: 1130412
- Fix build with perl 5.26
+ neoclust <neoclust>
- Rebuild against new Perl 5.26

* Sat Jun 18 2016 pterjan <pterjan> 2.220.0-15.mga6
+ Revision: 1023823
- Rebuild for perl 5.22.2

* Fri Feb 12 2016 umeabot <umeabot> 2.220.0-14.mga6
+ Revision: 956812
- Mageia 6 Mass Rebuild

* Sat Jun 27 2015 tv <tv> 2.220.0-13.mga6
+ Revision: 846153
- rebuild with soname-ified perl

* Wed Oct 15 2014 umeabot <umeabot> 2.220.0-12.mga5
+ Revision: 742704
- Second Mageia 5 Mass Rebuild

* Fri Sep 26 2014 tv <tv> 2.220.0-11.mga5
+ Revision: 725155
- rebuild for bogus file deps

* Tue Sep 16 2014 umeabot <umeabot> 2.220.0-10.mga5
+ Revision: 683659
- Mageia 5 Mass Rebuild

* Sun Dec 29 2013 guillomovitch <guillomovitch> 2.220.0-9.mga4
+ Revision: 563183
- add fedora patch to fix inlined functions (mga #12112)

* Fri Oct 18 2013 umeabot <umeabot> 2.220.0-8.mga4
+ Revision: 509443
- Mageia 4 Mass Rebuild

* Sun Jan 13 2013 umeabot <umeabot> 2.220.0-7.mga3
+ Revision: 363571
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Aug 12 2012 guillomovitch <guillomovitch> 2.220.0-6.mga3
+ Revision: 280824
- drop useless build dependencies
- adapt to new apache setup

* Sat Jul 07 2012 luigiwalser <luigiwalser> 2.220.0-5.mga3
+ Revision: 268689
- fix module configuration to work with systemd (mga #6714)

* Tue Mar 20 2012 luigiwalser <luigiwalser> 2.220.0-4.mga2
+ Revision: 225034
- httpd restart is handled by filetriggers now

* Mon Sep 19 2011 dmorgan <dmorgan> 2.220.0-3.mga2
+ Revision: 145253
- Fix buildrequires
- Fix apache requires

* Thu Jan 13 2011 jquelin <jquelin> 2.220.0-2.mga1
+ Revision: 9825
- imported package perl-CGI-SpeedyCGI


* Sun Oct 24 2010 Oden Eriksson <oeriksson@mandriva.com> 2.220.0-2mdv2011.0
+ Revision: 588140
- rebuild

* Sat Aug 01 2009 Jérôme Quelin <jquelin@mandriva.org> 2.220.0-1mdv2011.0
+ Revision: 406870
- rebuild using %%perl_convert_version

* Wed Jan 07 2009 Oden Eriksson <oeriksson@mandriva.com> 2.22-8mdv2009.1
+ Revision: 326701
- rebuild

* Sat Oct 11 2008 Guillaume Rousse <guillomovitch@mandriva.org> 2.22-7mdv2009.1
+ Revision: 292555
- force apache2 mod building
- fix buildrequires
- rebuild for linking

  + Oden Eriksson <oeriksson@mandriva.com>
    - sync slightly with fedora

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 2.22-3mdv2008.1
+ Revision: 136678
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request


* Thu Mar 08 2007 Thierry Vignaud <tvignaud@mandriva.com> 2.22-3mdv2007.1
+ Revision: 138542
- rebuild on dbarth request

  + Guillaume Rousse <guillomovitch@mandriva.org>
    - Import perl-CGI-SpeedyCGI

* Tue Jun 27 2006 Rafael Garcia-Suarez <rgarciasuarez@mandriva.com> 2.22-2mdv2007.0
- Rebuild for new perl

* Fri Jul 01 2005 Rafael Garcia-Suarez <rgarciasuarez@mandriva.com> 2.22-1mdk
- Initial Mandriva release

